﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

// pubblicato in questo thread:
// http://groups.google.com/group/microsoft.public.it.dotnet.csharp/browse_frm/thread/115b78a88be94f07/543e4900f150ed8a?q=mille+cento+raffaele&rnum=4&hl=en


namespace NumeriInItaliano
{
	/// <summary> 
	/// Conversione da numeri a stringe 'parlate' per valuta. 
	/// Il formato usato è quello degli assegni per cui 1320,97 viene convertito in: 
	/// milletrecentoventi/97 
	/// Arriva solo fino al biliardo :-) 
	/// 
	/// Copyright (c) Raffaele Rialdi, 2003 
	/// </summary> 
	public class ItalianConverter
	{
		// metodo da chiamare 
		public static string ToString(decimal d)
		{
			// Prendo i regional settings attualmente impostati sul thread 
			System.Globalization.CultureInfo ci =
		 System.Globalization.CultureInfo.CurrentCulture;
			// Prendo la formattazione dei numeri 
			System.Globalization.NumberFormatInfo nfi = ci.NumberFormat;
			// Prendo il numero di decimal dopo la virgola per la valuta 
			int fractnum = nfi.CurrencyDecimalDigits;
			// Prendo la porzione intera (per troncamento) del numero decimale 
			int Integral = (int)decimal.Truncate(d);
			// Prendo il numero di decimali (per troncamento) del numero decimale 
			// Si potrebbe usare Round per arrotondare secondo lo standard IEEE 
			int fractional = (int)decimal.Truncate((d - Integral) *
		 (decimal)System.Math.Pow(10, fractnum));


			return ToString(Integral) + "/" + fractional.ToString();
		}


		// array di stringhe con 
		private static string[,] num ={ 
   {"zero", "uno", "due", "tre", "quattro", "cinque", "sei", "sette", 
"otto", "nove"}, 
   {"dieci", "undici", "dodici", "tredici", "quattordici", "quindici", 
"sedici", "diciassette", "diciotto", "diciannove"}, 
   {"venti", "ventuno", "", "", "", "", "", "", "ventotto", ""}, 
   {"trenta", "trentuno", "", "", "", "", "", "", "trentotto", ""}, 
   {"quaranta", "quarantuno", "", "", "", "", "", "", "quarantotto", ""}, 
   {"cinquanta", "cinquantuno", "", "", "", "", "", "", "cinquantotto", ""}, 
   {"sessanta", "sessantuno", "", "", "", "", "", "", "sessantotto", ""}, 
   {"settanta", "settantuno", "", "", "", "", "", "", "settantotto", ""}, 
   {"ottanta", "ottantuno", "", "", "", "", "", "", "ottantotto", ""}, 
   {"novanta", "novantuno", "", "", "", "", "", "", "novantotto", ""} 
  };


		// conversione di un intero 
		private static string ToString(int n)
		{
			string tmp = n.ToString();


			// metto in un ArrayList stringhe costituite di blocchetti di 1,2 o 3 cifre 
			// Se n=1234 ArrayList avrà due oggetti con al[0]="234" e al[1]="1" 
			ArrayList al = new ArrayList();
			int i = tmp.Length;
			while(i > 3)
			{
				al.Add(tmp.Substring(i - 3, 3));
				i -= 3;
			}
			if(i != 0)
			{
				al.Add(tmp.Substring(0, i));
			}


			string blah = string.Empty;
			for(int j = al.Count - 1; j >= 0; j--)
			{
				string s = (string)al[j]; // recupero la stringa corrispondente al blocco 
				int tutto = int.Parse(s); // riconverto in intero 
				int primo = 0, secondo = 0, terzo = 0;
				if(s.Length == 3)
				{
					primo = int.Parse(s[0].ToString());
					secondo = int.Parse(s[1].ToString());
					terzo = int.Parse(s[2].ToString());
				}
				if(s.Length == 2)
				{
					secondo = int.Parse(s[0].ToString());
					terzo = int.Parse(s[1].ToString());
				}
				if(s.Length == 1)
				{
					terzo = int.Parse(s[0].ToString());
				}
				switch(j)
				{
					case 0:   // centinaia 
						blah += Tripletta(primo, secondo, terzo);
						break;
					case 1:   // migliaia 
						if(tutto == 1)
							blah += "mille";
						else
							blah += Tripletta(primo, secondo, terzo) + "mila";
						break;
					case 2:   // milioni 
						if(tutto == 1)
							blah += "unmilione";
						else
							blah += Tripletta(primo, secondo, terzo) + "milioni";
						break;
					case 3:   // miliardi 
						if(tutto == 1)
							blah += "unmiliardo";
						else
							blah += Tripletta(primo, secondo, terzo) + "miliardi";
						break;
					case 4:   // biliardi 
						if(tutto == 1)
							blah += "unbiliardo";
						else
							blah += Tripletta(primo, secondo, terzo) + "biliardi";
						break;
					default:  // comporre i biliardi 
						blah += "formato non supportato";
						break;
				}
			}


			return blah;
		}


		// conversione di una tripletta 
		private static string Tripletta(int primo, int secondo, int terzo)
		{
			string res = string.Empty;
			if(primo == 1) res += "cento";
			if(primo > 1) res += num[0, primo] + "cento";
			string t = num[secondo, terzo];
			if(t == string.Empty) t = num[secondo, 0] + num[0, terzo];
			if(t != "zero")
				res += t;
			return res;
		}

	}





}
